VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "No Control Breaks (Grand Total Only)"
   ClientHeight    =   2730
   ClientLeft      =   5355
   ClientTop       =   3975
   ClientWidth     =   5175
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2730
   ScaleWidth      =   5175
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   795
      Left            =   1140
      TabIndex        =   1
      Top             =   1440
      Width           =   2895
   End
   Begin VB.CommandButton cmdPrint 
      Caption         =   "Print Northwind Sales Report"
      Height          =   795
      Left            =   1140
      TabIndex        =   0
      Top             =   300
      Width           =   2895
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
    
' Variables to hold values for fields of the
' current input record ...
Private mstrYearMonth               As String
Private mstrOrderNbr                As String
Private mstrOrderDate               As String
Private mstrCustID                  As String
Private mstrProdDesc                As String
Private msngUnitPrice               As Single
Private mintQty                     As Integer
Private msngDiscountPct             As Single
    
Private mintLineCtr                 As Integer
Private mintPageCtr                 As Integer
Private mintSalesFileNbr            As Integer
Private mblnEOF                     As Boolean

Private Const mintLINE_START_POS    As Integer = 6

'-----------------------------------------------------------------------------
Private Sub cmdPrint_Click()
'-----------------------------------------------------------------------------
    
    Dim intX                As Integer
    Dim strCustFileName     As String
    Dim strBackSlash        As String

    Dim dblExtPriceDtl      As Double
    Dim dblDiscAmtDtl       As Double
    Dim dblSaleTotDtl       As Double
    
    Dim dblExtPriceGrand    As Double
    Dim dblDiscAmtGrand     As Double
    Dim dblSaleTotGrand     As Double
    
    Const intLINES_PER_PAGE As Integer = 47
    
    ' set up error-handler
    On Error GoTo cmdPrint_Click_Error

    ' Have the user make sure his/her printer is ready ...
    If MsgBox("Make sure your printer is on-line and " _
            & "loaded with paper.", vbOKCancel, "Check Printer") = vbCancel _
    Then
        Exit Sub
    End If
    
    ' The following For/Next loop is used to set the printer's font to Courier.
    ' It loops through the Printer object's Fonts property array, looking for the
    ' first font name that starts with "Courier". Once such a font name is found,
    ' that font is assigned to the FontName property, thus making Courier
    ' (or "Courier New" or "Courier PS") the current font for the printer, and the
    ' loop then exits via "Exit For". If, for whatever reason, no font name starting
    ' with "Courier" is found, then the default font for the printer will be used.
    For intX = 0 To Printer.FontCount - 1
        If Printer.Fonts(intX) Like "Courier*" Then
            Printer.FontName = Printer.Fonts(intX)
            Exit For
        End If
    Next
    
    ' Set printer font size and orientation ...
    Printer.FontSize = 10
    Printer.Orientation = vbPRORLandscape
    
    ' initialize page counter ...
    mintPageCtr = 0
                    
    ' prepare file name & number
    strBackSlash = IIf(Right$(App.Path, 1) = "\", "", "\")
    strCustFileName = App.Path & strBackSlash & "NWSALES.txt"
    mintSalesFileNbr = FreeFile

    ' open the input file
    Open strCustFileName For Input As #mintSalesFileNbr
    
    ' print first page report headings
    Call PrintHeadings
    
    ' initialize the grand totals
    dblExtPriceGrand = 0
    dblDiscAmtGrand = 0
    dblSaleTotGrand = 0
    
    ' priming read
    Call ReadSalesRecord
    
    ' main processing loop
    Do Until mblnEOF
                                              
        ' if the number of lines printed so far exceeds the
        ' maximum number of lines allowed on a page, invoke
        ' the PrintHeadings sub to do a page break
        If mintLineCtr > intLINES_PER_PAGE Then
            Call PrintHeadings
        End If
        
        dblExtPriceDtl = msngUnitPrice * mintQty
        dblDiscAmtDtl = dblExtPriceDtl * msngDiscountPct
        dblSaleTotDtl = dblExtPriceDtl - dblDiscAmtDtl
                         
        ' print a line of data
        Printer.Print Tab(mintLINE_START_POS); _
                      mstrYearMonth; _
                      Tab(11 + mintLINE_START_POS); _
                      mstrOrderDate; _
                      Tab(23 + mintLINE_START_POS); _
                      mstrOrderNbr; _
                      Tab(30 + mintLINE_START_POS); _
                      mstrCustID; _
                      Tab(37 + mintLINE_START_POS); _
                      mstrProdDesc; _
                      Tab(70 + mintLINE_START_POS); _
                      Format$(Format$(msngUnitPrice, "##0.00"), "@@@@@@"); _
                      Tab(79 + mintLINE_START_POS); _
                      Format$(mintQty, "@@@"); _
                      Tab(84 + mintLINE_START_POS); _
                      Format$(Format$(dblExtPriceDtl, "Currency"), String$(11, "@")); _
                      Tab(96 + mintLINE_START_POS); _
                      Format$(Format$(dblDiscAmtDtl, "Currency"), String$(11, "@")); _
                      Tab(108 + mintLINE_START_POS); _
                      Format$(Format$(dblSaleTotDtl, "Currency"), String$(11, "@"))
        ' increment the line count
        mintLineCtr = mintLineCtr + 1
        
        ' "roll" the detail amounts to the grand totals
        dblExtPriceGrand = dblExtPriceGrand + dblExtPriceDtl
        dblDiscAmtGrand = dblDiscAmtGrand + dblDiscAmtDtl
        dblSaleTotGrand = dblSaleTotGrand + dblSaleTotDtl

        ' read the next record
        Call ReadSalesRecord
             
    Loop

    ' end of main processing loop - time to print the grand totals
    
    ' make sure we have enough room to print the lines for the grand total
    If mintLineCtr > (intLINES_PER_PAGE - 2) Then
        Call PrintHeadings
    End If
    
    Printer.Print
    Printer.FontBold = True
    Printer.Print Tab(70 + mintLINE_START_POS); _
                  "GRAND TOTALS:"; _
                  Tab(84 + mintLINE_START_POS); _
                  Format$(Format$(dblExtPriceGrand, "Currency"), String$(11, "@")); _
                  Tab(96 + mintLINE_START_POS); _
                  Format$(Format$(dblDiscAmtGrand, "Currency"), String$(11, "@")); _
                  Tab(108 + mintLINE_START_POS); _
                  Format$(Format$(dblSaleTotGrand, "Currency"), String$(11, "@"))
    Printer.FontBold = False
    
    ' close the input file
    Close #mintSalesFileNbr

    ' Important! When done, the EndDoc method of the Printer object must be invoked.
    ' The EndDoc method terminates a print operation sent to the Printer object,
    ' releasing the document to the print device or spooler.
    Printer.EndDoc
    
    cmdExit.SetFocus

    Exit Sub

cmdPrint_Click_Error:
    If MsgBox("Error # " & Err.Number & " - " & Err.Description & vbNewLine & _
              "Do you want to continue?", _
              vbYesNo + vbQuestion, _
              "Error") = vbYes Then
        Resume Next
    Else
        End
    End If

End Sub

'-----------------------------------------------------------------------------
Private Sub cmdExit_Click()
'-----------------------------------------------------------------------------
    End
End Sub

'-----------------------------------------------------------------------------
Private Sub ReadSalesRecord()
'-----------------------------------------------------------------------------

    If EOF(mintSalesFileNbr) Then
        mblnEOF = True
    Else
        Input #mintSalesFileNbr, mstrYearMonth, _
                                 mstrOrderDate, _
                                 mstrOrderNbr, _
                                 mstrCustID, _
                                 mstrProdDesc, _
                                 msngUnitPrice, _
                                 mintQty, _
                                 msngDiscountPct
    End If

End Sub

'-----------------------------------------------------------------------------
Private Sub PrintHeadings()
'-----------------------------------------------------------------------------
    
    ' If we are about to print any page other than the first, invoke the NewPage
    ' method to perform a page break. The NewPage method advances to the next
    ' printer page and resets the print position to the upper-left corner of the
    ' new page.
    If mintPageCtr > 0 Then
        Printer.NewPage
    End If
    ' increment the page counter
    mintPageCtr = mintPageCtr + 1

    ' Print 4 blank lines, which provides a for top margin. These four lines do NOT
    ' count toward the limit of 47 lines.
    Printer.Print
    Printer.Print
    Printer.Print
    Printer.Print
    
    ' Print the main headings
    Printer.Print Tab(mintLINE_START_POS); _
                  "Print Date: "; _
                  Format$(Date, "mm/dd/yy"); _
                  Tab(mintLINE_START_POS + 50); _
                  "THEVBPROGRAMMER.COM"; _
                  Tab(mintLINE_START_POS + 110); _
                  "Page:"; _
                  Format$(mintPageCtr, "@@@")
    Printer.Print Tab(mintLINE_START_POS); _
                  "Print Time: "; _
                  Format$(Time, "hh:nn:ss"); _
                  Tab(mintLINE_START_POS + 45); _
                  "NORTHWIND TRADERS SALES REPORT"
    Printer.Print Tab(mintLINE_START_POS + 39); _
                  "WITH NO CONTROL BREAKS (GRAND TOTALS ONLY)"
    Printer.Print
    ' Print the column headings
    Printer.Print Tab(mintLINE_START_POS); _
                  "YEAR/"; _
                  Tab(23 + mintLINE_START_POS); _
                  "ORDER  CUST"; _
                  Tab(72 + mintLINE_START_POS); _
                  "UNIT"; _
                  Tab(87 + mintLINE_START_POS); _
                  "EXTENDED"; _
                  Tab(99 + mintLINE_START_POS); _
                  "DISCOUNT"
    Printer.Print Tab(mintLINE_START_POS); _
                  "MONTH"; _
                  Tab(11 + mintLINE_START_POS); _
                  "ORDER DATE  NUMBER  ID"; _
                  Tab(37 + mintLINE_START_POS); _
                  "PRODUCT DESCRIPTION"; _
                  Tab(71 + mintLINE_START_POS); _
                  "PRICE   QTY"; _
                  Tab(88 + mintLINE_START_POS); _
                  "PRICE"; _
                  Tab(100 + mintLINE_START_POS); _
                  "AMOUNT   SALE TOTAL"
    Printer.Print Tab(mintLINE_START_POS); _
                  "-----"; _
                  Tab(11 + mintLINE_START_POS); _
                  "----------  ------  --"; _
                  Tab(37 + mintLINE_START_POS); _
                  "-------------------"; _
                  Tab(71 + mintLINE_START_POS); _
                  "-----   ---"; _
                  Tab(88 + mintLINE_START_POS); _
                  "-----"; _
                  Tab(100 + mintLINE_START_POS); _
                  "------   ----------"
    Printer.Print
    ' reset the line counter to reflect the number of lines that have now
    ' been printed on the new page.
    mintLineCtr = 8

End Sub
